/*----------------------------------------------------------
	ȒPDirectMusicNX  EasyMusic.cpp
									2000.01.04 (c)C+ Factory
------------------------------------------------------------
Tv
@DirectMusicȒPɎg߂̃NXłBAf[^̓
ݍ݁AĐȒPɏo悤ɂȂĂ܂BMIDIۂɓǂ
ރZOǵAOɍ邽߁A[U[RɎg݌v
ȂĂ܂B܂AdĐpɁA~[WbNptH[}X
ǉ邱Ƃo܂B

gp

CEasyMusic MyMusic;//EasyMusicNX`
IDirectMusicSegment *lpMidi = NULL;//ZOg`

MyMusic.InitDxMusic(NULL,"",true);//
lpMidi = MyMusic.LoadMusic(NULL,"Music1.mid");//MIDI[h
MyMusic.PlayMusic(lpMidi,100,0,0);//ZOgĐ

//
MyMusic.ReleaseMusic(NULL,lpMidi);//ZOg̉
RELEASE(lpMidi)
----------------------------------------------------------*/

#include "stdafx.h"
#include "EasyMusic.h"

//---------------------------------------------------
//֐	CEasyMusic()
//@\		CEasyMusicNX̃RXgN^
//---------------------------------------------------
CEasyMusic::CEasyMusic()
{
	m_lpPort = NULL;
	m_nSeq = DX_FALSE;
	m_lpDMSegmentStat = NULL;
}

//---------------------------------------------------
//֐	~CEasyMusic()
//@\		CEasyMusicNX̃fXgN^
//---------------------------------------------------
CEasyMusic::~CEasyMusic()
{
	m_nSeq = DX_FALSE;

	RELEASE(m_lpDMSegmentStat)
	RELEASE(m_lpDMComposer);
	RELEASE(m_lpPort);
	m_lpDMPerf->CloseDown();
	m_lpDMPerf->Release();
	RELEASE(m_lpDMusic);
	RELEASE(m_lpDMLoader);

	CoUninitialize();
}

//---------------------------------------------------
//֐	InitDxMusic()
//@\		
//---------------------------------------------------
bool CEasyMusic::InitDxMusic(LPDIRECTSOUND lpDxSound,char *strSerchPath,bool bDefault)
{
	bool ret = false;
	HRESULT hRet;

	if(m_nSeq != DX_FALSE) return ret;

	hRet = CoInitialize(NULL);//COM
	if(FAILED(hRet)) return ret;//COM̏Ɏs

	//DirectMusic̏
	hRet = CoCreateInstance(CLSID_DirectMusicPerformance,NULL,CLSCTX_INPROC,IID_IDirectMusicPerformance,(void**)&m_lpDMPerf);
	if(FAILED(hRet)) return ret;//s

	hRet = m_lpDMPerf->Init(&m_lpDMusic,lpDxSound,NULL);
	if(FAILED(hRet)) return ret;//s
	m_lpDxSound = lpDxSound;
	
	//[_[
	hRet = CoCreateInstance(CLSID_DirectMusicLoader,NULL,CLSCTX_INPROC,IID_IDirectMusicLoader,(void**)&m_lpDMLoader);
	if(FAILED(hRet)) return ret;//s


	WCHAR wstrAppPath[MAX_PATH];
	char strAppPath[MAX_PATH];

	if(strlen(strSerchPath) < 1) {//T[`pX󂾂spXw
		GetAppPath(strAppPath,sizeof(strAppPath));
	}
	else {//w肳ĂAwg
		strcpy(strAppPath,strSerchPath);
	}
	MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,strAppPath,-1,wstrAppPath,MAX_PATH);//UNIɕϊ
	m_lpDMLoader->SetSearchDirectory(GUID_DirectMusicAllTypes,wstrAppPath,FALSE);
	
	//|[g̑I
	DMUS_PORTCAPS dmCaps;
	DMUS_PORTPARAMS dmParam;

	//|[g쐬pp[^ݒ
	ZeroMemory(&dmParam,sizeof(dmParam));
	dmParam.dwSize = sizeof(dmParam);
	dmParam.dwChannelGroups = 1;
	dmParam.dwValidParams = DMUS_PORTPARAMS_CHANNELGROUPS | DMUS_PORTPARAMS_EFFECTS;

	int i;
	bool bPortFound = false;
	hRet = S_OK;

	if(!bDefault) {
		//gȃ|[gT
		for(i = 0; hRet == S_OK; i++) {
			ZeroMemory(&dmCaps,sizeof(dmCaps));
			dmCaps.dwSize = sizeof(dmCaps);
			hRet = m_lpDMusic->EnumPort(i,&dmCaps);
			if(hRet == S_OK && dmCaps.dwClass == DMUS_PC_OUTPUTCLASS) {
				hRet = m_lpDMusic->CreatePort(dmCaps.guidPort,&dmParam,&m_lpPort,NULL);//|[g쐬
				if(SUCCEEDED(hRet))	bPortFound = true;
				break;
			}
		}
	}
	if(bPortFound){//|[g쐬łꍇ
		hRet = m_lpPort->Activate(TRUE);
		hRet = m_lpDMPerf->AddPort(m_lpPort);//|[gǉ
		hRet = m_lpDMPerf->AssignPChannelBlock(0,m_lpPort,1);
	}	
	else {//ǂȃ|[gȂ̂ŁAftHg|[ggp
		m_lpPort = NULL;
		hRet = m_lpDMPerf->AddPort(NULL);//ftHgI
		if(FAILED(hRet)) return ret;//s
	}
	hRet = CoCreateInstance(CLSID_DirectMusicComposer,NULL,CLSCTX_INPROC,IID_IDirectMusicComposer,(void**)&m_lpDMComposer);
	if(FAILED(hRet)) return ret;//s

	m_nSeq = INIT_OK;
	ret = true;
	return ret;
}

//...................................................
//֐	GetAppPath()				[Private]
//@\		spX擾
//...................................................
void CEasyMusic::GetAppPath(char *strAppPath,int nSize)
{
	char *cpName;

	//spX擾A쐬
	GetModuleFileName(NULL,strAppPath,nSize);
	cpName = strrchr(strAppPath,'\\');
	cpName++;
	*cpName = NULL;
}

//---------------------------------------------------
//֐	LoadMusic()
//@\		MIDI[h
//---------------------------------------------------
IDirectMusicSegment* CEasyMusic::LoadMusic(IDirectMusicPerformance *lpDMPer,char *strFileName)
{
	HRESULT hRet;
	DMUS_OBJECTDESC ObjectDesc;
	WCHAR wstrFileName[MAX_PATH];
	IDirectMusicSegment *lpDMSegment;

	if(m_nSeq != INIT_OK) return NULL;

	//[hIuWFNg̏ݒ
	ObjectDesc.dwSize = sizeof(ObjectDesc);
	ObjectDesc.guidClass = CLSID_DirectMusicSegment;
	ObjectDesc.dwValidData = DMUS_OBJ_CLASS | DMUS_OBJ_FILENAME;

	//t@Cw
	MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,strFileName,-1,wstrFileName,MAX_PATH);//UNIɕϊ
	wcscpy(ObjectDesc.wszFileName,wstrFileName);

	hRet = m_lpDMLoader->GetObject(&ObjectDesc,IID_IDirectMusicSegment2,(void**)&lpDMSegment);
	if(FAILED(hRet)) return NULL;//s

	if(lpDMPer == NULL) {
		lpDMSegment->SetParam(GUID_StandardMIDIFile,0xffffffff,0,0,(void**)m_lpDMPerf);
		lpDMSegment->SetParam(GUID_Download,0xffffffff,0,0,(void**)m_lpDMPerf);
	}
	else {
		lpDMSegment->SetParam(GUID_StandardMIDIFile,0xffffffff,0,0,(void**)lpDMPer);
		lpDMSegment->SetParam(GUID_Download,0xffffffff,0,0,(void**)lpDMPer);
	}

	return lpDMSegment;
}

//---------------------------------------------------
//֐	PlayMusic()
//@\		MIDIw񐔍Đ
//---------------------------------------------------
bool CEasyMusic::PlayMusic(IDirectMusicSegment *lpDMSegment,int nLoopCount,
						   MUSIC_TIME StartTime,MUSIC_TIME MinusEndTime)
{
	bool ret = false;
	HRESULT hRet;
	MUSIC_TIME EndTime;

	if(m_nSeq != INIT_OK || lpDMSegment == NULL) return ret;
	m_lpDMPerf->Stop(NULL,NULL,0,0);//~

	RELEASE(m_lpDMSegmentStat)

	hRet = lpDMSegment->GetLength(&EndTime);//Ȃ̒擾
	if(FAILED(hRet)) return ret;//s
	//l̃`FbN
	if(MinusEndTime >= (EndTime - StartTime)) MinusEndTime = 0;
	if(StartTime >= EndTime) StartTime = 0;

	hRet = lpDMSegment->SetStartPoint(StartTime);//擪ݒ
	hRet = lpDMSegment->SetLoopPoints(StartTime,EndTime-MinusEndTime);//[vݒ
	hRet = lpDMSegment->SetRepeats(nLoopCount);//[v񐔂ݒ

	m_lpDMComposer->AutoTransition(m_lpDMPerf,lpDMSegment,DMUS_COMMANDT_END,
					DMUS_COMPOSEF_BEAT | DMUS_COMPOSEF_MODULATE,NULL,NULL,NULL, NULL);

//	m_lpDMPerf->PlaySegment(lpDMSegment,DMUS_SEGF_BEAT,0, &m_lpDMSegmentStat);
//	if(FAILED(hRet)) return ret;//s

	ret = true;
	return ret;
}

//---------------------------------------------------
//֐	StopMusic()
//@\		t~
//---------------------------------------------------
bool CEasyMusic::StopMusic(IDirectMusicPerformance *lpDMPer)
{
	bool ret = false;
	HRESULT hRet;

	if(m_nSeq != INIT_OK) return ret;

	if(lpDMPer == NULL)
		hRet = m_lpDMPerf->Stop(NULL,NULL,0,0);//~
	else
		hRet = lpDMPer->Stop(NULL,NULL,0,0);//~
	if(FAILED(hRet)) return ret;//s

	ret = true;
	return ret;
}

//---------------------------------------------------
//֐	ReleaseMusic()
//@\		ZOg̉
//---------------------------------------------------
bool CEasyMusic::ReleaseMusic(IDirectMusicPerformance *lpDMPer,IDirectMusicSegment *lpDMSegment)
{
	bool ret = false;
	HRESULT hRet;

	if(m_nSeq != INIT_OK || lpDMSegment == NULL) return ret;

	StopMusic(lpDMPer);
	if(lpDMPer == NULL)	hRet = lpDMSegment->SetParam(GUID_Unload,0xffffffff,0,0,(void**)m_lpDMPerf);
		else				hRet = lpDMSegment->SetParam(GUID_Unload,0xffffffff,0,0,(void**)lpDMPer);
	if(FAILED(hRet)) return ret;//s

	ret = true;
	return ret;
}

//͕̃~[WbNptH[}Xgꍇ̊֐

//---------------------------------------------------
//֐	AddMusicPerformance()
//@\		~[WbNptH[}X
//---------------------------------------------------
IDirectMusicPerformance* CEasyMusic::AddMusicPerformance()
{
	HRESULT hRet;
	IDirectMusicPerformance *lpDMPerf;
	if(m_nSeq != INIT_OK) return NULL;

	//DirectMusicPerformancȅ
	hRet = CoCreateInstance(CLSID_DirectMusicPerformance,NULL,CLSCTX_INPROC,IID_IDirectMusicPerformance2,(void**)&lpDMPerf);
	if(FAILED(hRet)) return NULL;//s

	hRet = lpDMPerf->Init(&m_lpDMusic,m_lpDxSound,NULL);
	if(FAILED(hRet)) return NULL;//s

	//|[gݒ肷
	if(	m_lpPort != NULL){
		hRet = lpDMPerf->AddPort(m_lpPort);//|[gǉ
		hRet = lpDMPerf->AssignPChannelBlock(0,m_lpPort,1);
	}	
	else {
		hRet = lpDMPerf->AddPort(NULL);//ftHgI
	}
	if(FAILED(hRet)) return NULL;//s

	return lpDMPerf;
}

//---------------------------------------------------
//֐	PlayMusicEx()
//@\		MIDIw񐔍Đ(ZJ_ptH[}X)
//---------------------------------------------------
bool CEasyMusic::PlayMusicEx(IDirectMusicPerformance *lpDxPer,IDirectMusicSegment *lpDMSegment,
							 int nLoopCount,MUSIC_TIME StartTime,MUSIC_TIME MinusEndTime)
{
	bool ret = false;
	HRESULT hRet;
	MUSIC_TIME EndTime;

	if(m_nSeq != INIT_OK || lpDMSegment == NULL || lpDxPer == NULL) return ret;

	StopMusic(lpDxPer);
	hRet = lpDMSegment->GetLength(&EndTime);//Ȃ̒擾
	if(FAILED(hRet)) return ret;//s
	//l̃`FbN
	if(MinusEndTime >= (EndTime - StartTime)) MinusEndTime = 0;
	if(StartTime >= EndTime) StartTime = 0;

	hRet = lpDMSegment->SetStartPoint(StartTime);//擪ݒ
	hRet = lpDMSegment->SetLoopPoints(StartTime,EndTime-MinusEndTime);//[vݒ
	hRet = lpDMSegment->SetRepeats(nLoopCount);//[v񐔂ݒ

	m_lpDMComposer->AutoTransition(lpDxPer,lpDMSegment,DMUS_COMMANDT_END,
					DMUS_COMPOSEF_MEASURE | DMUS_COMPOSEF_MODULATE,NULL,NULL,NULL, NULL);

	if(FAILED(hRet)) return ret;//s

	ret = true;
	return ret;
}
