//-----------------------------------------------------------------
//            EasyDraw & EasySound & EasyMusic eXgvO
//                                              (c)2000 C+ Factory
//-----------------------------------------------------------------

#include "stdafx.h"
#include "resource.h"
#include "EasyDraw.h"
#include "EasySound3D.h"
#include "EasyMusic.h"

bool bWindow = true;//EBhE[h̏ꍇTrueɂ

HRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM);//bZ[W

void InitGame();//
void InitDxDraw();//EasyDraw
void GameMain();//C
void ReleaseAll();//

HWND hWnd;			// EChEnh

//NX錾
CEasyDraw MyDraw;		//EasyDrawIuWFNg
CEasySound3D MySound3D;	//EasySoundIuWFNg
CEasyMusic MyMusic;

POINT pKaoPos[64];
bool bKaoKind[64];
LPDIRECTDRAWSURFACE7 lpSprite01,lpSprite02;	//XvCg
SOUND_DATA_3D pDsoundData[3];		//ZJ_obt@&3Dobt@\
IDirectMusicSegment *lpMidi01 = NULL;

//---------------------------------------------------
//֐	WinMain()
//@\		C֐
//---------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow )
{

	WNDCLASSEX wndclass;//EBhENX
	MSG msg;			//bZ[W

	// EChENX̐
	ZeroMemory( &wndclass, sizeof( wndclass));
	wndclass.style		= 0;
	wndclass.lpfnWndProc = WinProc;
	wndclass.cbClsExtra	= 0;
	wndclass.cbWndExtra	= 0;
	wndclass.hInstance	= hInstance;
	wndclass.hCursor	= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wndclass.lpszClassName = "Easy Lib Test";
	wndclass.cbSize		= sizeof(WNDCLASSEX);

	if( !RegisterClassEx( &wndclass)) {
		MessageBox(NULL,"EBhẼWXgɎsB","Error",MB_OK|MB_ICONEXCLAMATION);
		return 0;
	}
	// EChE̐
	hWnd = CreateWindowEx(NULL,"Easy Lib Test","Easy Lib Test",WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,640,480,HWND_DESKTOP, NULL,hInstance, NULL);

	ShowWindow( hWnd,SW_SHOW);
	UpdateWindow( hWnd);

	InitGame();//

	//^C}[̐ݒ ^C}[ŉĐ܂
	SetTimer(hWnd,1,2000,NULL);//2b
	SetTimer(hWnd,2,1000,NULL);//1b
	SetTimer(hWnd,3,3000,NULL);//3b

	// C bZ[W [v:
	while(TRUE) 
	{
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT){
				PostQuitMessage(msg.wParam);
				return 0;
			}
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		GameMain();//C
	}
	return 0;
}

//---------------------------------------------------
//֐	InitDxDraw()
//@\		EasyDraw
//---------------------------------------------------
void InitDxDraw()
{
	//EasyDraw
	if(bWindow) {
		if(!MyDraw.InitDxDrawWindow(hWnd)) return;//EBhE[h
//		SetWindowLong(hWnd,GWL_STYLE,WS_OVERLAPPEDWINDOW);
	}
	else {
		if(!MyDraw.InitDxDraw(hWnd,640,480,16)) return;//tXN[[h
//		SetWindowLong(hWnd,GWL_STYLE,WS_POPUP);//EBhE̗]vȕ
	}
	//ʂNA
	MyDraw.ClsBackBuffer();
	MyDraw.EasyFlip();

    DDCOLORKEY          ddck;		// J[L[
	ddck.dwColorSpaceLowValue  = 0; // w
	ddck.dwColorSpaceHighValue = 0;

	MyDraw.CreateSurface(lpSprite01,32,32);		//XvCgT[tFX
	lpSprite01->SetColorKey(DDCKEY_SRCBLT, &ddck);	//J[L[ݒ
	MyDraw.SetBitmap(lpSprite01,"IDB_KAO",32,32);	//rbg}bvݒ

	MyDraw.CreateSurface(lpSprite02,32,32);
	lpSprite02->SetColorKey(DDCKEY_SRCBLT, &ddck);
	MyDraw.SetBitmap(lpSprite02,"IDB_KAO2",32,32);
	//XvCgp^[\z
	int i;
	srand( (unsigned)time( NULL ) );
	for(i = 0; i < 64; i++) {
		if(i < 32 )	bKaoKind[i] = true;	
			else	bKaoKind[i] = false;
		pKaoPos[i].x = rand() % 640+420;
		pKaoPos[i].y = rand() % 800 - 700;
	}
}

//---------------------------------------------------
//֐	InitGame()
//@\		Q[
//---------------------------------------------------
void InitGame()
{
	InitDxDraw();//EasyDraw

	//EasySound
	MySound3D.InitDxSound(hWnd,2,22050,16);//EBhEnhnď
	MySound3D.MakeSoundBuffer(pDsoundData[0],IDR_WAVE_LEFT);//obt@&WAVEo^
	MySound3D.MakeSoundBuffer(pDsoundData[1],IDR_WAVE_CENTER);
	MySound3D.MakeSoundBuffer(pDsoundData[2],IDR_WAVE_RIGHT);

	//DirectMusic
	MyMusic.InitDxMusic(MySound3D.GetDirectSound(),"",true);
	lpMidi01 = MyMusic.LoadMusic(NULL,"rank.mid");
	MyMusic.PlayMusic(lpMidi01,-1,0,0);//-1́Aقږ[vł
}

//---------------------------------------------------
//֐	GameMain()
//@\		Q[̃C
//---------------------------------------------------
void GameMain()
{
	int i;

	RECT	srcrect;
	srcrect.left = 0;
	srcrect.top  = 0;
	srcrect.bottom = 32;
	srcrect.right  = 32;

	if(MyDraw.ClsBackBuffer()) {//obNobt@NA
		//XvCg`
		for(i = 0; i < 64; i++) {
			if(bKaoKind[i])
				MyDraw.m_lpBackBuffer->BltFast(pKaoPos[i].x,pKaoPos[i].y,lpSprite01,&srcrect,DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
			else
				MyDraw.m_lpBackBuffer->BltFast(pKaoPos[i].x,pKaoPos[i].y,lpSprite02,&srcrect,DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
			pKaoPos[i].x -= 3;
			pKaoPos[i].y += 2;
			if(pKaoPos[i].x < 0 || pKaoPos[i].y > 480) {//WZbg
				pKaoPos[i].x = rand() % 1024+200;
				pKaoPos[i].y = 0;
			}
		}
		MyDraw.EasyFlip();//tbv
	}
}
//---------------------------------------------------
//֐	ReleaseAll()
//@\		IuWFNg̉
//---------------------------------------------------
void ReleaseAll()
{
	//t~@ZOg
	MyMusic.ReleaseMusic(NULL,lpMidi01);
	RELEASE(lpMidi01)
	//TEhobt@
	MySound3D.ReleaseBuffer(pDsoundData[0]);
	MySound3D.ReleaseBuffer(pDsoundData[1]);
	MySound3D.ReleaseBuffer(pDsoundData[2]);

	//XvCgT[tFX
	RELEASE(lpSprite01);
	RELEASE(lpSprite02);
	//DirectX̃IuWFNĝ̂́Aꂼ̃NX̃fXgN^ŉ
}


//---------------------------------------------------
//֐	WinProc()
//@\		C EBhẼbZ[W܂B
//---------------------------------------------------
HRESULT CALLBACK WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message) {
		case WM_LBUTTONDOWN://ʃ[h̐؂ւ
			//IuWFNg̉
			RELEASE(lpSprite01);
			RELEASE(lpSprite02);
			MyDraw.ReleaseAll();
			//tO؂ւ
			if(bWindow) bWindow = false;
			else 		bWindow = true;
			InitDxDraw();//EasyDraw

			break;
		case WM_DESTROY://I
			ReleaseAll();//IuWFNg
			MyDraw.ReleaseAll();
			PostQuitMessage(0);
			break;
		case WM_TIMER://^C}[
			switch(wParam) {
				case 1:
					MySound3D.PlaySE(pDsoundData[0],-2,0,0);//Ww肵čĐ@
					break;
				case 2:
					MySound3D.PlaySE(pDsoundData[1],0,0,0);//^
					break;
				case 3:
					MySound3D.PlaySE(pDsoundData[2],2,0,0);//E
					break;
			}
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}


